var _regex_1 = new RegExp( "^[aiueo\\-]" );
var _regex_2 = new RegExp( "^[kstnhmyrwgzdbpx][aiueo]" );
var _regex_3 = new RegExp( "^n[^aiueo]" );
var _regex_4 = new RegExp( "^[ktshpg]y[auo]" );
var _regex_5 = new RegExp( "^([^aiueo])\\1" );
//var _regex_5 = new RegExp( "([kstnhmyrwgzdpb])\\1" );

var _romaji = " a i u e okakikukekosasisusesotatitutetonaninunenohahihuhehomamimumemoyayiyuyeyorarirurerowawiwuwewogagigugegozazizuzezodadidudedobabibubebopapipupepoxaxixuxeo -";
var _kana = "アイウエオカキクケコサシスセソタチツテトナニヌネノハヒフヘホマミムメモヤイユエヨラリルレロワイウエヲガギグゲゴザジズゼゾダヂヅデドバビブベボパピプペポァィゥェォ-";//ー";
var _hira = "あいうえおかきくけこさしすせそたちつてとなにぬねのはひふへほまみむめもやいゆえよらりるれろわいうえをがぎぐげござじずぜぞだぢづでどばびぶべぼぱぴぷぺぽぁぃぅぇぉ-";

var romaji = new Array();
initialize_romaji();

function initialize_romaji() {
    for ( var i = 0; i < _romaji.length; i++ ) {
        var alphabet = _romaji.substring( i * 2, i * 2 + 2 );
        if ( alphabet.charAt( 0 ) == ' ' ) {
            alphabet = alphabet.substring( 1, 2 );
        }
        romaji[ alphabet ] = _kana[ i ];
    }
}

function convertLetter1( letter ) {
    if ( letter == 'a' ) return 'ア';
}

function convertToKana( input ) {
    var converted = "";
    input = input.toLowerCase();
    input = input.replace( /ji/g, 'zi' );
    input = input.replace( /f/g, 'h' );
    input = input.replace( /l/g, 'x' );
    input = input.replace( /chi/g, 'ti' );
    input = input.replace( /ch/g, 'tiy' );
    input = input.replace( /dh/g, 'de' );
    input = input.replace( /nn/g, 'N' );
    input = input.replace( /ny/g, 'niy' );
    input = input.replace( /ts/g, 't' );
    input = input.replace( /shi/g, 'si' );
    input = input.replace( /sh/g, 'siy' );
    input = input.replace( /jy/g, 'j' );
    //DEBUG( input );
    while ( input.length > 0 ) {
        if ( input.match( _regex_1 ) || input.match( _regex_3 ) ){
            converted += romaji[ input.charAt( 0 ) ];
            input = input.substring( 1, input.length );
        } else if ( input.match( _regex_2 ) ) {
            converted += romaji[ input.substring( 0, 2 ) ];
            input = input.substring( 2, input.length );
        } else if ( input.match( _regex_4 ) ) {
            var c = input.charAt( 0 );
            input = input.substring( 1, input.length );
            if ( c == 'k' ) converted += 'キ';
            else if ( c == 't' ) converted += 'チ';
            else if ( c == 's' ) converted += 'シ';
            else if ( c == 'h' ) converted += 'ヒ';
            else if ( c == 'p' ) converted += 'ピ';
            else if ( c == 'g' ) converted += 'ギ';
        } else if ( input.match( _regex_5 ) ) { 
            input = input.substring( 1, input.length );
            converted += 'ツ';
        } else if ( input.charAt( 0 ) == 'N' ) {
            input = input.substring( 1, input.length );
            converted += 'ン';
        } else if ( input.charAt( 0 ) == 'j' ) {
            input = 'y' + input.substring( 1, input.length );
            converted += 'ジ';
        } else if ( input == 'n' ) {
            input = "";
            converted += 'ン';
        } else {
            input = input.substring( 1, input.length );
        }
    }
    return converted;
}

function convertHiraganaToKatakana( value ) {
    var katakana = "";
    for ( var i = 0; i < value.length; i++ ) {
        var ind = _hira.indexOf( value.charAt( i ) );
        if ( ind >= 0 ) {
            katakana += _kana.charAt( ind );
        } else {
            katakana += value.charAt( i );
        }
    }
    return katakana;
}

function _binarySearch( array, item, start, end ) {
    if ( end == start ) return end;
    var center = parseInt( ( start + end ) * .5 );
    var probe = array[ center ];
    if ( end - start == 1 ) {
        if ( probe < item ) return end;
        return start;
    }
    if ( probe == item ) return center;
    if ( item < probe ) {
        return _binarySearch( array, item, start, center );
    } else {
        return _binarySearch( array, item, center, end );
    }
}

function binaryAreaSearch( array, item ) {
    return [ _binarySearch( array, item , 0, array.length ),
             _binarySearch( array, item + "ンンンンンンンンンンンンンンンンンンンン", 0, array.length ) ];
}



var emptyArray = [];
var hint_bank;
var hint_division;
var code_bank;
var code_division;
var divisionData = emptyArray;

var elem_bankcode;
var elem_bankhint;

var elem_divcode;
var elem_divhint;

var elem_code;

function figure4( value ) {
    var num = "0000" + value;
    return num.substring( num.length - 4, num.length );
}

function receiveBankCode( bankname ) {
    var pos = _binarySearch( BANK, bankname, 0, BANK.length );
    //document.getElementById( "debugDiv" ).appendChild( document.createTextNode( "" + bankname + " " + CODE[ pos ] ) );
    elem_bankcode.value = BANK[ pos ];
//    DEBUG( "FOUND " + pos );
//     DEBUG( pos + " " + value );
    elem_divcode.value = "";
    code_bank = CODE[ pos ];
    divisionData = DIVISION[ code_bank ];
    if ( elem_code ) {
        elem_code.value = figure4( code_bank ) + "-";
    }
}

function receiveDivisionCode( value ) {
    if ( divisionData.length < 3 ) {
        DEBUG( divisionData.length );
        return;
    }
    //var range = binaryAreaSearch( divisionData[ 0 ], value );
    var pos   = _binarySearch( divisionData[ 0 ], value, 0, divisionData[ 0 ].length );
    //document.getElementById( "debugDiv" ).appendChild( document.createTextNode( "*" + value + "*" + CODE[ pos ] ) );
    //DEBUG( range + " " + value );
    code_division = divisionData[ 1 ][ pos ];//range[ 0 ] ];
    elem_divcode.value = value;
    elem_code.value = figure4( code_bank ) + "-" + figure4( code_division );
}

function setup() {
    elem_bankcode = document.getElementById( "bankcode" );
    elem_bankhint = document.getElementById( "bankhint" );
    hint_bank         = new HintProposer( elem_bankcode, elem_bankhint );
    hint_bank.setCandidateFunction( selectBank );
    hint_bank.addListener( receiveBankCode );
    
    elem_divcode  = document.getElementById( "divisioncode" );
    elem_divhint  = document.getElementById( "divisionhint" );
    hint_division     = new HintProposer( elem_divcode, elem_divhint );
    hint_division.setCandidateFunction( selectDivision );
    hint_division.addListener( receiveDivisionCode );
 
    elem_code = document.getElementById( "codenumber" );
}


function getKana( value ) {
    value = value.replace( /ー/g, "-" );
    if ( value.match( /^[a-zA-Z]/ ) ) {
        return convertToKana( value );
    } else if ( _hira.indexOf( value.charAt( 0 ) ) >= 0 ) {//value.match( /^[あ-ん\-]+$/ ) ) {
        return convertHiraganaToKatakana( value );
    } else if ( _kana.indexOf( value.charAt( 0 ) ) >= 0 ) {//value.match( /^[ア-ン\-]+$/ ) ) {
        return  value;
    } else {
        return null;
    }
}

function selectDivision( value ) {
    hint_bank.hideCandidates();
    if ( divisionData.length < 3 ) {
        return emptyArray;
    }
    var keyword = getKana( value );
    var range;
    if ( keyword == null ) {
        range = binaryAreaSearch( divisionData[ 2 ], value );
    } else {
        range = binaryAreaSearch( divisionData[ 0 ], keyword );
    }
    //var range = binaryAreaSearch( divisionData[ 0 ], value );
//    if ( range[ 1 ] - range[ 0 ] == 0 ) {
//         value = convertToKana( value );
//         range = binaryAreaSearch( divisionData[ 0 ], value );
//    }
    if ( range[ 1 ] - range[ 0 ] > 100 
         || range[ 1 ] - range[ 0 ] == 0 ) {
        return emptyArray;
    }
    var results = new Array();
    for ( var i = range[ 0 ]; i < range[ 1 ]; i++ ) {
        //results.push( [ divisionData[ 0 ][ i ], divisionData[ 1 ][ i ] + " " + divisionData[ 2 ][ i ] ] );
        results.push( [ divisionData[ 0 ][ i ], divisionData[ 2 ][ i ] ] );
    }
    return results;
//    DEBUG( value + " " + range );
}

function selectBank( value ) {
    hint_division.clearCandidates();
    hint_division.hideCandidates();
    if ( value.length < 2 ) {
        divisionData = emptyArray;
        return emptyArray;
    }
    var keyword = getKana( value );
    var range;
    if ( keyword == null ) {
        range = binaryAreaSearch( KANJI, value );
    } else {
        range = binaryAreaSearch( BANK, keyword );
    }
//     if ( range[ 1 ] - range[ 0 ] == 0 ) {
//         value = convertToKana( value );
//         range = binaryAreaSearch( BANK, value );
//     }
//     DEBUG( value + " " + range );
    if ( range[ 1 ] - range[ 0 ] > 100 
         || range[ 1 ] - range[ 0 ] == 0 ) {
        divisionData = emptyArray;
        return emptyArray;
    }
    var results = new Array();
    for ( var i = range[ 0 ]; i < range[ 1 ]; i++ ) {
        //results.push( [ CODE[ i ], CODE[ i ] + " " + KANJI[ i ] ] );
        results.push( [ BANK[ i ], KANJI[ i ] ] );
    }
    return results;
}


function hideAll() {
    hint_bank.hideCandidates();
    hint_division.hideCandidates();
}


function changed( event, element ) {
    var value = element.value;//"";
//     if ( hint_bank.isLocked || hint_division.isLocked ) {
//         DEBUG( "LOCKED" );
//         return;
//     } else {
//         value = hint_bank.isLocked + " , " +  hint_division.isLocked + " ";
//     }
//     for ( var i = 0; i < element.attributes.length; i++ ) {
//         value += element.attributes.item( i ).nodeName + "="
//             + element.attributes.item( i ).nodeValue + ",";
//     }
    DEBUG( document.getElementById( 'debugDiv' ).innerText + ":C:" + value );
}

function blurred( event, element ) {
    var value = element.value;//"";
//     if ( hint_bank.isLocked || hint_division.isLocked ) {
//         DEBUG( "LOCKED" );
//         return;
//     } else {
//         value = hint_bank.isLocked + " , " +  hint_division.isLocked + " ";
//     }
//     for ( var i = 0; i < element.attributes.length; i++ ) {
//         value += element.attributes.item( i ).nodeName + "="
//             + element.attributes.item( i ).nodeValue + ",";
//     }
    DEBUG( document.getElementById( 'debugDiv' ).innerText + ":B:" + value );
}

