// function DEBUG( message ) {
//     var elem = document.getElementById( 'status' );
//     elem.innerText = message;
// }

// temporary class for event passing
function _EventDelegator( ownerObj ) {
    this.owner = ownerObj;
    this.displayCandidates 
        = function(event) { this.owner.displayCandidates(event); };
    this.receiveValue
        = function(event) { this.owner.receiveValue(event);};
    this.receiveInput 
        = function(event) { this.owner.receiveInput(event);};
}

function HintProposer( inputElement, layer ) {//selectionElement ) {
    if ( inputElement == null || inputElement == undefined ) {
        throw new Error( "no input element" );
    }

    if ( layer == null || layer == undefined ) {
        throw new Error( "no selection element" );
    }
    this.inputElement     = inputElement;
    this.layer            = layer;

    this.maxSize          = 11;
    this.waitInterval     = 500;
    this.isWaiting        = false;
    this.displayFlag      = false;
    this.isLocked = false;

    this.setMaxSize        = _HintProposer_setMaxSize;
    this.getMaxSize        = _HintProposer_getMaxSize;
    this.getValue          = _HintProposer_getValue;
    this.hideCandidates    = _HintProposer_hideCandidates;
    this.displayCandidates = _HintProposer_displayCandidates;

    this.generateCandidates   = _HintProposer_generateCandidates;
    this.setCandidateFunction = _HintProposer_setCandidateFunction;
    this.clearCandidates      = _HintProposer_clearCandidates;

    this.addListener    = _HintProposer_addListener;
    this.removeListener = _HintProposer_removeListener;

    this._notifyValue   = _HintProposer__notifyValue;

    // set candidate position
    this.layer.style.display = "none";

    if ( document.devaultView ) { // IE does not have the property
        var computedStyle = document.defaultView.getComputedStyle( this.inputElement, "" );
        this.layer.style.position = "absolute";
        var left = parseInt( computedStyle.getPropertyValue( "left" ) );
        var top  = parseInt( computedStyle.getPropertyValue( "top" ) );
        var height = parseInt( computedStyle.getPropertyValue( "height" ) );
        
        if ( left != NaN ) {
            this.layer.style.left = left + "px";
        }
        if ( top != NaN && height != NaN ) {
            this.layer.style.top = ( top + height + 2 ) + "px";
        }
    }
    // event listeners
    this.receiveInput      = _HintProposer_receiveInput;
    this.receiveValue      = _HintProposer_receiveValue;
    this.receiveSelection  = _HintProposer_receiveSelection;
    this.eventListeners    = new Array();

    // register event listeners
    var listener = new _EventDelegator(this);
    inputElement.addEventListener( 'input', function(event){listener.receiveInput(event);}, true );
    inputElement.addEventListener( 'change', function(event){listener.receiveValue(event);}, true );
    inputElement.addEventListener( 'focus', function(event){ listener.displayCandidates(event);}, true );
}

function _HintProposer_addListener( listener ) {
    for ( var i = 0; i < this.eventListeners.length; i++ ) {
        if ( this.eventListeners[ i ] == listener ) return;
    }
    this.eventListeners.push( listener );
}

function _HintProposer_removeListener( listener ) {
    for ( var i = 0; i < this.eventListeners.length; i++ ) {
        if ( this.eventListeners[ i ] == listener ) {
            thie.eventListeners.splice( i, i + 1 );
            return;
        }
    }
}

function _HintProposer_setMaxSize( size ) {
    this.maxSize = size;
}

function _HintProposer_getMaxSize() {
    return this.maxSize;
}

function _HintProposer_getValue() {
    return this.inputElement.value;
}

function _SelectionListener( elem, owner ) {
    this.receiveSelection = function(event) {
        var option = this;
        var proposer = this.owner;
        //DEBUG( "selected " + option.value + " " + proposer );
        proposer.isLocked = true;
        //proposer.inputElement.value = option.value;
        proposer.inputElement.focus();
        // temporarily close candidate panel
        proposer.layer.style.display = "none";
        //
        var value = null;
        for ( var i = 0; i < option.attributes.length; i++ ) {
            if ( option.attributes.item( i ).nodeName == 'value' ) {
                value = option.attributes.item( i ).nodeValue;
                break;
            }
        }
        //var value = option.attributes.item( 0 ).value;
        //DEBUG( option.attributes. );
        //document.getElementById( "debugDiv" ).appendChild( document.createTextNode( '>' + value  + '<' ) );
        //DEBUG( option.value );
        if ( value != null ) {
            proposer._notifyValue( value );//option.value );
        }
        proposer.isLocked = false;
    }
}


function _eventCallBack( event ) {
    //DEBUG( "selected " + this );
}

function _HintProposer_setCandidateFunction( func ) {
    this.generateCandidates = func;
}

function _HintProposer_generateCandidates( value ) {
    var candidates = new Array();
    var len = value.length;
    for ( var i = 0; i < len; i++ ) {
        var code = value.charAt( i );
        var name = ">>>" + value.charAt( i ) + "<<<";
        candidates.push( [ code, name ] );
    }
    return candidates;
}

function _HintProposer_receiveInput( event ) {
    var candidates = this.generateCandidates( this.inputElement.value );

    var value = this.inputElement.value;
    var len = value.length;
    // clear contents
    this.layer.innerHTML = "";
    var self = this;
    for ( var i = 0; i < candidates.length; i++ ) {
        var elem = document.createElement( 'a' );

        elem.owner = this;
        elem.addEventListener( 'mouseup', (new _SelectionListener(elem,self)).receiveSelection, true );
        elem.setAttribute( 'value', candidates[ i ][ 0 ] );
        elem.appendChild( document.createTextNode( candidates[ i ][ 1 ]  ) );
        this.layer.appendChild( elem );
        this.layer.appendChild( document.createElement( 'br' ) );

        if ( i > this.maxSize ) {
            var span = document.createElement( 'span' );
            span.style.paddingLeft ="3em";
            span.appendChild( document.createTextNode( ':' ) );
            this.layer.appendChild( span );
            break;
        }
    }

    if ( this.displayFlag ) this.layer.style.display = "block";
    return;
}

function _HintProposer_clearCandidates() {
    this.layer.innerHTML = "";
    this.displayFlag = false;
    this.layer.style.display = "none";
}

function _HintProposer_displayCandidates() {
    this.displayFlag = true;
    this.layer.style.display = "block";
}

function _HintProposer_hideCandidates() {
    this.displayFlag = false;
    this.layer.style.display = "none";
}

function _HintProposer_receiveValue( event ) {
    //DEBUG( this.inputElement.id + " RECEIVED VALUE " + this.inputElement.value );
    //this._notifyValue( this.inputElement.value );
}

function _HintProposer_receiveSelection( event ) {
    DEBUG( this.inputElement.id + "RECEIVED SELECTION " + event + " : " + event.source.value );
}

function _HintProposer__notifyValue( value ) {
    //DEBUG( "NOTIFIED"  + value );
    for ( var i = 0; i < this.eventListeners.length; i++ ) {
        this.eventListeners[ i ]( value );
    }
}
